<?php
use MASCOTCOREROFOT\Lib;
use MASCOTCOREROFOT\CPT\Testimonials\CPT_Testimonials;



if(!function_exists('mascot_core_rofot_elementor_cpt_sc_testimonials_render_output')) {
	/**
	 * Output render
	 */
	function mascot_core_rofot_elementor_cpt_sc_testimonials_render_output( $class_instance, $settings ) {
		$new_cpt_class = $class_instance;
		$paged = isset($settings['paged']) ? $settings['paged'] : '';

		//if single post selected
		if( $settings['show_only_selected_single_post'] == 'yes' && !empty( $settings['selected_single_post'] )) {
			//query args
			$args = array(
				'p' => $settings['selected_single_post'],
				'post_type' => $new_cpt_class['ptKey'],
			);
		} else {
			//query args
			$args = array(
				'post_type' => $new_cpt_class['ptKey'],
				'orderby' => $settings['order_by'],
				'order' => $settings['order'],
				'posts_per_page' => $settings['total_items'],
				'paged' => $paged,
			);
			//if category selected
			if( ! empty( $settings['selected_category'] ) ) {
				$args['tax_query'] = array(
					array(
						'taxonomy' => $new_cpt_class['ptTaxKey'],
						'field' => 'slug',
						'terms' => explode(',', $settings['selected_category']),
					)
				);
			}
		}

		//if order by testimonial_author_name selected
		if( $settings['order_by'] == 'testimonial_author_name' ) {
			$args['meta_key'] = 'rofot_mascot_' . 'cpt_author_name';
			$args['orderby']  = 'meta_value';
		}

		$the_query = new \WP_Query( $args );
		$settings['the_query'] = $the_query;

		if ( !$the_query->have_posts() && isset( $settings['from_loadmore_ajax_handler'] ) && $settings['from_loadmore_ajax_handler'] === true ) {
			return;
		}
		

		//classes
		$classes = array();
		$classes[] = $settings['design_style'];
		if( $settings['show_quote_icon'] == 'yes' ) {
			$classes[] = 'testimonial-has-quote-icon';
		}
		if( !empty($settings['custom_quote_icon']) ) {
			$classes[] = 'testimonial-has-custom-quote-icon';
		}
		if( !empty($settings['custom_quote_icon_alignment']) ) {
			$classes[] = $settings['custom_quote_icon_alignment'];
		}
		$classes[] = $settings['custom_css_class'];
		$settings['classes'] = $classes;
		
		//ptTaxKey
		$settings['ptTaxKey'] = $new_cpt_class['ptTaxKey'];
		
		//Owl Carousel Data
		$settings['owl_carousel_data_info'] = rofot_mascot_prepare_owlcarousel_data_from_params( $settings );
		
		$settings['loadmore_btn_classes'] = rofot_mascot_prepare_button_classes_from_params( $settings, 'loadmore_' );

		//Produce HTML version by using the parameters (filename, variation, folder name, parameters, shortcode_ob_start)
		$html = mascot_core_rofot_elementor_get_cpt_shortcode_template_part( 'testimonials', $settings['display_type'], 'testimonials/tpl', $settings, true );
		
		echo $html;
	}
}